#include "chess.h"

struct history
{
  int piece;
  int chold[2];
  int cursor[2];
  int promote;
  int killed;
  int clocks[2];
  int clockrun;
  int moved;
  int castled;
  struct history *next;
};

history *first=NULL;

int perp=0,numsets,clocks[2],timeset,clockrun,castled=0,menus=0,puzzles=0;

char piece[2][6][4][6], setnum[2], savename[40]= {'a','b','c','1','3','2','e','l','i','\0'};

void getset()
{
  ifstream setget("Sets/set");
  setget>>setnum>>numsets;
  char set[10];
  strcpy(set,"Sets/set");
  strcat(set,setnum);
  ifstream newset(set);
  for (int a=0 ; a<2 ; a++)
    {
      for (int b=0 ; b<6 ; b++)
        {
          for (int c=3 ; c>=0 ; c--)
            { newset>>piece[a][b][c];
              spaceadd(piece[a][b][c]);
            }
        }
    }
}

void promote(side all[],int chose)
{
  first->promote=1;
  perp=1;
  char choice=' ';
  gotoxy(25,42);
  cout<<"(Q)ueen (B)ishop (K)night (R)ook";
  while(choice!='q' && choice!='b' && choice!='k' && choice!='r' && choice!='Q' && choice!='B' && choice!='K' && choice!='R')
    choice=_getch();
  gotoxy(25,42);
  cout<<"                                ";
  switch(choice)
    {
    case 'q':case 'Q':
      all[turn].pieces[chose].type=QUEEN;
      break;
    case 'b':case 'B':
      all[turn].pieces[chose].type=BISHOP;
      break;
    case 'r':case 'R':
      all[turn].pieces[chose].type=ROOK;
      break;
    case 'k':case 'K':
      all[turn].pieces[chose].type=KNIGHT;
      break;
    };
}
void showcheck()
{
  gotoxy(35, 42);
  cout<<"   CHECK!    ";
  wait(2);
  gotoxy(35, 42);
  cout<<"             ";
}

void sideinit(side all[])
{
  for(int a=0; a<2; a++)
    for(int b=0; b<16; b++)
      all[a].pieces[b].dead=all[a].pieces[b].moved=0;
  strcpy(all[0].nside, "White");
  strcpy(all[1].nside, "Black");
  int l, l2;
  for(int a=0; a<2; a++)
    {
      if(a==0)
	{
	  l=1;
	  l2=2;
	}
      else
	{
	  l=8;
	  l2=7;
	}
      for(int b=0; b<8; b++)
	all[a].pieces[b].type=PAWN;
      all[a].pieces[8].type=KNIGHT;
      all[a].pieces[9].type=KNIGHT;
      all[a].pieces[10].type=BISHOP;
      all[a].pieces[11].type=BISHOP;
      all[a].pieces[12].type=ROOK;
      all[a].pieces[13].type=ROOK;
      all[a].pieces[14].type=QUEEN;
      all[a].pieces[15].type=KING;
      for(int b=0; b<8; b++)
	{
	  all[a].pieces[b].x=b+1;
	  all[a].pieces[b].y=l2;
	}
      for(int b=8; b<16; b++)
	all[a].pieces[b].y=l;
      all[a].pieces[8].x=2;
      all[a].pieces[9].x=7;
      all[a].pieces[10].x=3;
      all[a].pieces[11].x=6;
      all[a].pieces[12].x=1;
      all[a].pieces[13].x=8;
      all[a].pieces[14].x=4;
      all[a].pieces[15].x=5;
    }
  gotoxy(4, 1);
  cout<<"WHITE DEAD";
  gotoxy(66, 1);
  cout<<"BLACK DEAD";
  gotoxy(15, 1);
  for (int x=1 ; x<9 ; x++)
    {
      for (int y=1 ; y<9 ; y++)
        {
          if ((x+y)%2==0)
            textbackground(RED);
          else
            textbackground(GREEN);
          for (int z=0 ; z<5 ; z++)
            {
              gotoxy(6*y+10,5*x+z-3);
              cprintf("%s","      ");
            }
        }
    }	
  gotoxy(2, 50);
  char write[2]= {196,NULL},write2[2]={218,NULL};
  textbackground(WHITE);
  gotoxy(2,49);
  textcolor(DARKGRAY);
  cprintf("%s",write2);
  write2[0]=191;
  for(int a=0; a<76; a++)
    cprintf("%s",write);
  cprintf("%s",write2);
  write2[0]=179;
  gotoxy(2,50);
  textcolor(DARKGRAY);
  cprintf("%s", write2);
  textcolor(BLACK);
  cprintf("%s","F");
  textcolor(DARKGRAY);
  cprintf("%s", "ile       -Chess version 1.1 by Eli Luberoff and Sam Bollier-    ");
  textcolor(BLACK);
  cprintf("%s", "O");
  textcolor(DARKGRAY);
  cprintf("%s", "ptions   ");
  cprintf("%s", write2);
}

void pfind(side all[], int chose)
{
  int a=abs(turn-1);
  for(int b=0; b<16; b++)
    {
      if((all[a].pieces[b].y==all[turn].pieces[chose].y) && (all[a].pieces[b].x==all[turn].pieces[chose].x) && (all[a].pieces[b].dead==0))
	{
	  perp=0;
	  all[a].pieces[b].dead=1;
	  first->killed=b;
	}
    }
}

int checkcheck(side all[], int x, int y)
{
  int num=0;
  turn=abs(turn-1);
  int chold[2], temp[2];
  temp[0]=cursor[0];
  temp[1]=cursor[1];
  cursor[0]=x;
  cursor[1]=y;
  for (int a=0 ; a<16 ; a++)
    {
      chold[0]=all[turn].pieces[a].x;
      chold[1]=all[turn].pieces[a].y;
      if (all[turn].pieces[a].type==QUEEN)
        if(queenmove(chold,all)==1 && all[turn].pieces[a].dead==0)
          num++;
      if (all[turn].pieces[a].type==KING)
        if(kingmove(chold,all)==1 && all[turn].pieces[a].dead==0)
          num++;
      if (all[turn].pieces[a].type==PAWN)
        if(pawnmove(a,chold,all)==1 && all[turn].pieces[a].dead==0)
          num++;
      if (all[turn].pieces[a].type==ROOK)
        if(rookmove(chold,all)==1 && all[turn].pieces[a].dead==0)
          num++;
      if (all[turn].pieces[a].type==BISHOP)
        if(bishopmove(chold,all)==1 && all[turn].pieces[a].dead==0)
          num++;
      if (all[turn].pieces[a].type==KNIGHT)
        if(knightmove(chold,all)==1 && all[turn].pieces[a].dead==0)
          num++;
    }
  turn=abs(turn-1);
  cursor[0]=temp[0];
  cursor[1]=temp[1];
  return num;
}

int selpiece(side all[])
{
  int b;
  for(int a=0; a<16; a++)
    {
      if(all[turn].pieces[a].x==cursor[0] && all[turn].pieces[a].y==cursor[1] && all[turn].pieces[a].dead==0)
	{
	  b=a;
	  break;
	}
    }
  return b;
}

void erasespace(int x, int y)
{
  gotoxy(10+6*x, 5*(9-y)-3);
  cout<<"     ";
  gotoxy(10+6*x, 5*(9-y)-2);
  cout<<"     ";
  gotoxy(10+6*x, 5*(9-y)-1);
  cout<<"     ";
  gotoxy(10+6*x, 5*(9-y));
  cout<<"     ";
}

void drawdead(side all[])
{
  int dc[2], num, dnum[2], don;
  dc[0]=dc[1]=1;
  dnum[0]=dnum[1]=0;
  for(int a=0; a<2; a++)
    for(int b=0; b<16; b++)
      if(all[a].pieces[b].dead==1)
	dnum[a]++;
  for(int a=0; a<2; a++)
    {
      num=8;
      don=0;
      if(a==0)
	num-=5;
      for(int b=0; b<16; b++)
	{
	  if(all[a].pieces[b].dead==1)
	    {
	      gotoxy(num+(don*6)+58*a, 5*dc[a]+3);
	      cout<<piece[a][all[a].pieces[b].type][0];
	      gotoxy(num+(don*6)+58*a, 5*dc[a]+2);
	      cout<<piece[a][all[a].pieces[b].type][1];
	      gotoxy(num+(don*6)+58*a, 5*dc[a]+1);
	      cout<<piece[a][all[a].pieces[b].type][2];
	      gotoxy(num+(don*6)+58*a, 5*dc[a]);
	      cout<<piece[a][all[a].pieces[b].type][3];
	      don=abs(don-1);
	      if(don==0)
		dc[a]++;
	    }
	}
    }
}

int piececheck(side all[], int x, int y)
{
  for(int a=0; a<16; a++)
    {
      if(all[turn].pieces[a].x==x && all[turn].pieces[a].y==y && all[turn].pieces[a].dead==0)
	return 1;
      if(all[abs(turn-1)].pieces[a].x==x && all[abs(turn-1)].pieces[a].y==y && all[abs(turn-1)].pieces[a].dead==0)
	return 2;
    }
  return 0;
}

int rookmove(int chold[], side all[])
{
  if (abs(cursor[0]-chold[0])!=0 && abs(cursor[1]-chold[1])!=0)
    return 0;
  int b=(cursor[0]-chold[0]!=0) ? cursor[0]-chold[0] : cursor[1]-chold[1];
  if(cursor[0]-chold[0]==0)
    for(int a=1; a<abs(b); a++)
      {
	if(cursor[1]-chold[1]>0)
	  {
	    if(piececheck(all, chold[0], chold[1]+a)!=0)
	      return 0;
	  }
	else
	  {
	    if(piececheck(all, chold[0], chold[1]-a)!=0)
	      return 0;
	  }
      }
  else
    for(int a=1; a<abs(b); a++)
      {
	if(cursor[0]-chold[0]>0)
	  {
	    if(piececheck(all, chold[0]+a, chold[1])!=0)
	      return 0;
	  }
	else
	  {
	    if(piececheck(all, chold[0]-a, chold[1])!=0)
	      return 0;
	  }
      }
  if(piececheck(all, cursor[0], cursor[1])!=1)
    return 1;
  return 0;
}

int bishopmove(int chold[], side all[])
{
  int a=abs(chold[0]-cursor[0]);
  if(abs(cursor[0]-chold[0])==abs(cursor[1]-chold[1]))
    {
      for(int b=1 ; b<a ; b++)
       if(piececheck(all,chold[0]+b*(cursor[0]-chold[0])/a,chold[1]+b*(cursor[1]-chold[1])/a)!=0)
	    return 0;
      if (piececheck(all,cursor[0],cursor[1])!=1)
	return 1;
    }
  return 0;
}

int castle(side all[],int chold[])
{
  if(all[turn].pieces[15].moved==0)
    {
      if(cursor[0]-chold[0]==2)
	if(all[turn].pieces[13].moved==0)
	  {
	    if(piececheck(all, 6, all[turn].pieces[15].y)==0 && piececheck(all, 7, all[turn].pieces[15].y)==0 && checkcheck(all,all[turn].pieces[15].x,all[turn].pieces[15].y)==0 && checkcheck(all, 6, all[turn].pieces[15].y)==0 && checkcheck(all, 7, all[turn].pieces[15].y)==0)
	      {
		erasespace(all[turn].pieces[13].x, all[turn].pieces[13].y);
		all[turn].pieces[13].x=6;
                castled=1;
		return 1;
	      }
	    else
	      return 0;
	  }
      if(cursor[0]-chold[0]==-2)
	if(all[turn].pieces[12].moved==0)
	  {
	      if(piececheck(all, 2, all[turn].pieces[15].y)==0 && piececheck(all, 3, all[turn].pieces[15].y)==0 && piececheck(all, 4, all[turn].pieces[15].y)==0 && checkcheck(all,all[turn].pieces[15].x,all[turn].pieces[15].y)==0 && checkcheck(all, 2, all[turn].pieces[15].y)==0 && checkcheck(all, 3, all[turn].pieces[15].y)==0 && checkcheck(all, 4, all[turn].pieces[15].y)==0)
		{
		  erasespace(all[turn].pieces[12].x, all[turn].pieces[12].y);
		  all[turn].pieces[12].x=4;
                  castled=1;
		  return 1;
		}
	      else
		return 0;
	  }
    }
  return 0;
}

int kingmove(int chold[], side all[])
{
  if(cursor[1]-chold[1]==0)
    if(castle(all,chold)==1)
      return 1;
  if(piececheck(all, cursor[0], cursor[1])!=1 && abs(cursor[1]-chold[1])<2 && abs(cursor[0]-chold[0])<2)
    return 1;
  return 0;
}

int queenmove(int chold[], side all[])
{
  if(cursor[0]-chold[0]==0 || cursor[1]-chold[1]==0)
    return rookmove(chold, all);
  return bishopmove(chold, all);
}

int knightmove(int chold[], side all[])
{
  if(((abs(cursor[0]-chold[0])==2 && abs(cursor[1]-chold[1])==1) || (abs(cursor[0]-chold[0])==1 && abs(cursor[1]-chold[1])==2)) && piececheck(all,cursor[0],cursor[1])!=1)
    return 1;
  return 0;
}

int pawnmove(int chose, int chold[], side all[])
{
  if(chold[0]==cursor[0])
    {
      if((turn==0 && cursor[1]-chold[1]==1) || (turn==1 && cursor[1]-chold[1]==-1))
	if (piececheck(all, cursor[0], cursor[1])==0)
	  return 1;
      if(((turn==0 && cursor[1]-chold[1]==2) || (turn==1 && cursor[1]-chold[1]==-2)) && all[turn].pieces[chose].moved==0)
	if (piececheck(all, cursor[0], cursor[1])==0)
	  if(piececheck(all, cursor[0], cursor[1]+turn*2-1)==0)
	    return 1;
    }
  else
    {
      if((turn==0 && cursor[1]-chold[1]==1) || (turn==1 && cursor[1]-chold[1]==-1))
	if(abs(cursor[0]-chold[0])==1)
	  if(piececheck(all, cursor[0], cursor[1])==2)
	    return 1;
    }
  return 0;
}

void movepiece(int chose, side all[])
{
  erasespace(all[turn].pieces[chose].x, all[turn].pieces[chose].y);
  history *f=first;
  first=new(history);
  first->next=f;
  first->chold[0]=all[turn].pieces[chose].x;
  first->chold[1]=all[turn].pieces[chose].y;
  first->moved=all[turn].pieces[chose].moved;
  all[turn].pieces[chose].x=cursor[0];
  all[turn].pieces[chose].y=cursor[1];
  all[turn].pieces[chose].moved=1;
  first->killed=-1;
  first->clocks[0]=clocks[0];
  first->clocks[1]=clocks[1];
  first->clockrun=clockrun;
  first->piece=chose;
  first->castled=castled;
  for (int x=0 ; x<2 ; x++)
    first->cursor[x]=cursor[x];
  first->promote=0;
  pfind(all, chose);
}

int pfind2(side all[], int chose)
{
  int a=abs(turn-1);
  for(int b=0; b<16; b++)
    {
      if((all[a].pieces[b].y==all[turn].pieces[chose].y) && (all[a].pieces[b].x==all[turn].pieces[chose].x) && (all[a].pieces[b].dead==0))
	return b;
    }
  return 100;
}

int intocheck(side all[], int chose, int chold[])
{
  int kill;
  all[turn].pieces[chose].x=cursor[0];
  all[turn].pieces[chose].y=cursor[1];
  kill=pfind2(all,chose);
  if (kill!=100)
    all[abs(turn-1)].pieces[kill].dead=1;
  int a=checkcheck(all, all[turn].pieces[15].x, all[turn].pieces[15].y);
  if (kill!=100)
    all[abs(turn-1)].pieces[kill].dead=0;
  all[turn].pieces[chose].x=chold[0];
  all[turn].pieces[chose].y=chold[1];
  if (a>1)
    a=1;
  return abs(a-1);
}

int movpiece(side all[], int chose, int chold[],int x)
{
  int suc;
  if (all[turn].pieces[chose].type==PAWN)
    suc=pawnmove(chose, chold, all);
  if (all[turn].pieces[chose].type==KNIGHT)
    suc=knightmove(chold,all);
  if (all[turn].pieces[chose].type==BISHOP)
    suc=bishopmove(chold,all);
  if (all[turn].pieces[chose].type==ROOK)
    suc=rookmove(chold, all);
  if (all[turn].pieces[chose].type==QUEEN)
    suc=queenmove(chold, all);
  if (all[turn].pieces[chose].type==KING)
    suc=kingmove(chold, all);
  if (suc==1)
    suc=intocheck(all,chose,chold)==1;
  if (suc==1 && x==0)
    movepiece(chose, all);
  if (all[turn].pieces[chose].type==PAWN && (all[turn].pieces[chose].y==1 || all[turn].pieces[chose].y==8))
    promote(all,chose);
  return suc;
}

int checkmatecheck(side all[])
{
  int temp[2],chold[2];
  temp[0]=cursor[0];
  temp[1]=cursor[1];
  for (int a=0 ; a<16 ; a++)
    {
      if (all[turn].pieces[a].dead==0)
        {
          for (int x=1 ; x<9 ; x++)
            {
              for (int y=1 ; y<9 ; y++)
                {
                   chold[0]=all[turn].pieces[a].x;
	           chold[1]=all[turn].pieces[a].y;
                   cursor[0]=x;
                   cursor[1]=y;
	           if (movpiece(all,a,chold,1)==1)
                     {
                       cursor[0]=temp[0];
                       cursor[1]=temp[1];
		       return 0;
                     }
                 }
             }
        }
    }
  cursor[0]=temp[0];
  cursor[1]=temp[1];
  return 1;
}

void stalemate()
{
  gotoxy(35,42);
  cout<<"STALEMATE!   ";
}

void changeset(side all[])
{
  ifstream infile("Sets/set");
  int x,y;
  char choice='3';
  gotoxy(15, 47);
  cout<<"   Type the number of the set (1-"<<numsets<<") or (R)esume";
  while (choice=='1' || choice=='2' || choice=='3' || choice=='4' || choice=='5' || choice=='6' || choice=='7' || choice=='8' || choice=='9')
    {
      choice=_getch();
      switch(choice)
        {
        case '1':case '2':case '3': case '4': case '5': case '6': case '7': case '8': case '9':
          if (choice-48<=numsets)
            {
              ofstream outfile("Sets/set");
              infile>>x>>y;
              outfile<<choice<<" "<<numsets;
              outfile.close();
              getset();
              drawboard(all,1);
              drawdead(all);
            }
          break;
        case 'q': case 'Q':
            _setcursortype(_NORMALCURSOR);
	    textbackground(BLACK);
	    textcolor(LIGHTGRAY);
            clrscr();
            exit(0);
            break;
        };
    }
  gotoxy(15, 47);
  cout<<"                                                        ";
}

void drawboard(side all[],int as)
{
  gotoxy(35, 45);
  if(turn==0)
    cout<<"White's Turn";
  else
    {
      cout<<"Black's Turn";
    }
  for(int a=0; a<2; a++)
    {
      if(a==0)
	textcolor(WHITE);
      else
	textcolor(BLACK);
      for(int b=0; b<16; b++)
	{
	  if(all[a].pieces[b].x%2==1 && all[a].pieces[b].y%2==1)
	    textbackground(GREEN);
	  if(all[a].pieces[b].x%2==1 && all[a].pieces[b].y%2==0)
	    textbackground(RED);
	  if(all[a].pieces[b].x%2==0 && all[a].pieces[b].y%2==1)
	    textbackground(RED);
	  if(all[a].pieces[b].x%2==0 && all[a].pieces[b].y%2==0)
	    textbackground(GREEN);
	  if(all[a].pieces[b].dead==0 &&(as==1 || first==NULL ||b==first->piece || castled==1))
	    {
  	      gotoxy(10+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y));
	      cprintf("%s", piece[a][all[a].pieces[b].type][0]);
	      gotoxy(10+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y)-1);
	      cprintf("%s", piece[a][all[a].pieces[b].type][1]);
	      gotoxy(10+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y)-2);
	      cprintf("%s", piece[a][all[a].pieces[b].type][2]);
	      gotoxy(10+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y)-3);
	      cprintf("%s", piece[a][all[a].pieces[b].type][3]);
	      gotoxy(10+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y)+1);
	      cprintf("%s", "     ");
	      gotoxy(15+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y));
	      cprintf("%s", " ");
	      gotoxy(15+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y)-1);
	      cprintf("%s", " ");
	      gotoxy(15+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y)-2);
	      cprintf("%s", " ");
	      gotoxy(15+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y)-3);
	      cprintf("%s", " ");
	      gotoxy(15+6*all[a].pieces[b].x, 5*(9-all[a].pieces[b].y)+1);
	      cprintf("%s", " ");
	    }
	}
    }
}

void drawtime()
{
  gotoxy(19, 45);
  if (clocks[0]<600)
    cout<<" ";
  cout<<(clocks[0]-clocks[0]%60)/60<<":";
  if (clocks[0]%60<10)
    cout<<"0";
  cout<<clocks[0]%60;
  gotoxy(56, 45);
  if (clocks[1]<600)
    cout<<" ";
  cout<<(clocks[1]-clocks[1]%60)/60<<":";
  if (clocks[1]%60<10)
    cout<<"0";
  cout<<clocks[1]%60;
  if(turn==0)
  {
    gotoxy(18, 44);
    cout<<"ͻ";
    gotoxy(18, 46);
    cout<<"ͼ";
    gotoxy(55, 44);
    cout<<"Ŀ";
    gotoxy(55, 46);
    cout<<"";
    gotoxy(18, 45);
    cout<<"";
    gotoxy(24, 45);
    cout<<"";
    gotoxy(55, 45);
    cout<<"";
    gotoxy(61, 45);
    cout<<"";
  }
  else
  {
    gotoxy(18, 44);
    cout<<"Ŀ";
    gotoxy(18, 46);
    cout<<"";
    gotoxy(55, 44);
    cout<<"ͻ";
    gotoxy(55, 46);
    cout<<"ͼ";
    gotoxy(18, 45);
    cout<<"";
    gotoxy(24, 45);
    cout<<"";
    gotoxy(55, 45);
    cout<<"";
    gotoxy(61, 45);
    cout<<"";
  }
}

void drawcursor(int act, int chold[])
{
  char a[7];
  a[0]=a[1]=a[2]=a[3]=a[4]=a[5]=24;
  a[6]=NULL;
  textbackground(BLACK);
  textcolor(WHITE);
  for (int ab=0 ; ab<4 ; ab++)
    {
      gotoxy(15+6*chold[0], 5*(9-chold[1])-ab);
      cout<<char(32-15*act);
    }
  gotoxy(10+6*cursor[0], 5*(9-cursor[1])+1);
  cprintf("%s",a);
}

void savegame(side all[], int clocks[], int chold[], int act,char fname[])
{
  gotoxy(25, 48);
  char buf[25];
  strcpy(buf, "saved/");
  strcat(buf, fname);
  ofstream gamesave(buf);
  for(int a=0; a<2; a++)
    {
      for(int b=0; b<16; b++)
	gamesave<<all[a].pieces[b].x<<' '<<all[a].pieces[b].y<<' '<<all[a].pieces[b].type<<' '<<all[a].pieces[b].moved<<' '<<all[a].pieces[b].dead<<' ';
    }
  for(int b=0; b<2; b++)
    gamesave<<clocks[b]<<' '<<chold[b]<<' '<<cursor[b]<<' ';
  gotoxy(25, 48);
  cout<<"                             ";
  gamesave<<' '<<act<<' '<<clockrun<<' '<<setnum<<' '<<turn;
}

int loadgame(side all[], int clocks[], int chold[], int act,char fname[])
{
  int clockam;
  ifstream infile("time");
  infile>>clockrun>>clockam;
  clrscr();
  sideinit(all);
  gotoxy(25, 48);
  char buf[60];
  strcpy(buf, "saved/");
  buf[6]='\0';
  strcat(buf, fname);
  ifstream gameload(buf);
  for(int a=0; a<2; a++)
    {
      for(int b=0; b<16; b++)
	gameload>>all[a].pieces[b].x>>all[a].pieces[b].y>>all[a].pieces[b].type>>all[a].pieces[b].moved>>all[a].pieces[b].dead;
    }
  for(int b=0; b<2; b++)
    gameload>>clocks[b]>>chold[b]>>cursor[b];
  gameload>>act>>clockrun>>setnum>>turn;
  ofstream outfile("Sets\\set");
  outfile<<setnum<<' '<<numsets;
  getset();
  outfile.close();
  ofstream outfile2("time");
  outfile2<<clockrun<<' '<<clockam;
  outfile2.close();
  drawboard(all,0);
  gotoxy(25, 48);
  cout<<"                             ";
  drawdead(all);
  return act;
}

void drawcursor2()
{
  if ((cursor[0]+cursor[1])%2)
    textbackground(RED);
  else
    textbackground(GREEN);
  gotoxy(10+6*cursor[0], 5*(9-cursor[1])+1);
  cprintf("%s","      ");
}

void getfname(char filename[])
{
  _setcursortype(_NORMALCURSOR);
  char a;
  getchar();
  gotoxy(1,1);
  cout<<"Enter name: ";
  cin.get(a);
  cin.get(filename,41);
  cin.get(a);
  filename[30]='\0';
  _setcursortype(_NOCURSOR);
}

void getname(char filename[], int ls)
{
  char choice;
  int num=0;
  char fname[48][41];
  system("del resfile");
  system("dir saved > resfile");
  ifstream testfile("resfile");
  char c;
  char buffer[100];
  int i=0,z=0,x;
  while (i<7)
    {
      testfile.get(c);
      if (c=='\n') i++;
    }
  testfile.get(buffer,45);
  testfile.get(fname[0],41);
  testfile.get(c);
  while (z==0)
    {
      num++;
      for (x=0 ; x<44 ; x++)
        {
          testfile.get(c);
          if (c=='\n')
            {
              z++;
              break;
            }
        }
      if (z==0)
        {
          testfile.get(fname[num],41);
          testfile.get(c);
        }
    }
  clrscr();
  gotoxy(30,50);
  cout<<"(C)ancel  (E)nd game";
  for (x=0 ; x<num ; x++)
    {
      gotoxy(40-ceil((float)strlen(fname[x])/2),2+x);
      cout<<fname[x];
    }
  if (ls)
    {
      gotoxy(36,2+num);
      cout<<"New File";
    }
  int line=2;
  z=0;
  while(z==0)
    {
      gotoxy(24,line);
      cout<<char(16);
      gotoxy(54,line);
      cout<<char(17);
      choice=_getch();
      gotoxy(24,line);
      cout<<" ";
      gotoxy(54,line);
      cout<<" ";
      switch(choice)
	{
	case 'c': case 'C':
	  strcpy(filename,"ab13513s");
	  z=1;
	  break;
	case 'q': case 'Q':
	  clrscr();
          _setcursortype(_NORMALCURSOR);
	  textbackground(BLACK);
	  textcolor(LIGHTGRAY);
	  exit(0);
	  break;
	case 13:
	  if (line==2+num)
	    getfname(filename);
	  else
	    strcpy(filename,fname[line-2]);
	  z=1;
	  break;
	case 72:
	  line--;
	  if (line==1)
	    line=num+1+ls;
	  break;
	case 80:
	  line++;
	  if (line==num+2+ls)
	    line=2;
	  break;
	};
    }
}

void gettime()
{
  ifstream infile("time");
  infile>>clockrun>>clocks[1];
  clocks[0]=clocks[1]+clockrun;
}

void clockerase()
{
  textbackground(BLACK);
  gotoxy(1,44);
  cout<<"                                                               "<<endl<<"                              "<<endl<<"                                                                        ";
  gotoxy(55,45);
  cout<<"                             ";
}

void onoff()
{
  clockrun=abs(clockrun-1);
  int x;
  ifstream infile("time");
  infile>>x>>x;
  ofstream outfile("time");
  outfile<<clockrun<<' '<<x;
  outfile.close();
  if (clockrun==0)
    clockerase();
  else
    clocks[turn]++;
}

int getnum()
{
  _setcursortype(_NORMALCURSOR);
  char a[10];
  int x=0;
  char key='h';
  while(key!=char(13))
    {
      key=_getch();
      switch(key)
        {
        case 13:  
	  a[x]='\0';
	  break;
        case 8:
          if (x!=0)
            {
              cout<<(char)key;
              cout<<" ";
              cout<<(char)key;
              x-=2;
            }
          else
            x--;
          break;
        case 'q': case 'Q':
          clrscr();
          _setcursortype(_NORMALCURSOR);
	  textbackground(BLACK);
	  textcolor(LIGHTGRAY);
          exit(0);
	case 'c': case 'C':
	  _setcursortype(_NOCURSOR);
	  return -1;
        default:
          if (x!=2)
            {
              cout<<(char)key;
              a[x]=(char)key;
            }
          else
            x--;
          break;
        };
      x++;
    }
  _setcursortype(_NOCURSOR);
  return atoi(a);
}

void settimes()
{
  int min, sec;
  gotoxy(36,46);
  cout<<char(218)<<char(196)<<char(196)<<char(196)<<char(196)<<char(196)<<char(191);
  gotoxy(36,47);
  cout<<char(179)<<"  :  "<<char(179);
  gotoxy(36,48);
  cout<<char(192)<<char(196)<<char(196)<<char(196)<<char(196)<<char(196)<<char(217);
  gotoxy(37,47);
  min=getnum();
  gotoxy(40,47);
  if (min>-1)
    sec=getnum();
  if (min>-1 && sec>-1)
    {
      clocks[0]=clocks[1]=60*min+sec;
      clocks[turn]+=clockrun;
    }
  ofstream outfile("time");
  outfile<<clockrun<<' '<<clocks[abs(turn-1)];
  outfile.close();
  gotoxy(36,46);
  cout<<"       ";
  gotoxy(36,47);
  cout<<"       ";
  gotoxy(36,48);
  cout<<"       ";
}

void changetimes()
{
  int min,sec;
  gotoxy(19,45);
  cout<<"  :  ";
  gotoxy(56,45);
  cout<<"  :  ";
  gotoxy(19,45);
  min=getnum();
  gotoxy(22,45);
  if (min!=-1)
    sec=getnum();
  if (min>-1 && sec>-1)
    clocks[0]=min*60+sec;
  gotoxy(56,45);
  if (min>-1 && sec>-1)
    min=getnum();
  gotoxy(59,45);
  if (min>-1 && sec>-1)
    sec=getnum();
  if (min>-1 && sec>-1)
    clocks[1]=min*60+sec;
  drawtime();
  clocks[turn]++;
}

void clockstuff()
{
  gotoxy(15, 47);
  char a;
  cout<<" (S)et times, (C)hange time, (O)n/(O)ff, (R)eset";
  a=_getch();
  gotoxy(15, 47);
  cout<<"                                                ";
  switch(a)
    {
    case 's':
      settimes();
      break;
    case 'c':
      if (clockrun)
	changetimes();
      break;
    case 'o':
      onoff();
      break;
    case 'r':
      gettime();
      break;
    case 'e': case 'E':
      clrscr();
      _setcursortype(_NORMALCURSOR);
      textbackground(BLACK);
      textcolor(LIGHTGRAY);
      exit(0);
    };
}

void clrdead(side all[])
{
  for (int x=2 ; x<40 ; x++)
    {
      gotoxy(3,x);
      cout<<"           ";
      gotoxy(66,x);
      cout<<"           ";
    }
  drawdead(all);
}

void back(side all[])
{
  history *f;
  erasespace(first->cursor[0],first->cursor[1]);
  all[turn].pieces[first->piece].x=first->chold[0];
  all[turn].pieces[first->piece].y=first->chold[1];
  clockrun=first->clockrun;
  clocks[0]=first->clocks[0];
  clocks[1]=first->clocks[1];
  all[turn].pieces[first->piece].moved=first->moved;
  if (first->promote==1)
    all[turn].pieces[first->piece].type=PAWN;
  if (first->killed>-1)
    {
      all[abs(turn-1)].pieces[first->killed].dead=0;
      clrdead(all);
      drawboard(all,1);
    }
  castled=first->castled;
  if (castled)
    {
      if (cursor[0]==3)
        {
          erasespace(4,1+7*turn);
          all[turn].pieces[12].x=1;
        }
      else
        {
          erasespace(6,1+7*turn);
          all[turn].pieces[13].x=8;
        }
    }
  drawboard(all,0);
  f=first->next;
  delete first;
  first=f;
}

void drawfile()
{
  char a[2]= {218,NULL},aa[9]={196,196,196,196,196,196,196,196,NULL};
  textcolor(DARKGRAY);
  textbackground(WHITE);
  gotoxy(2,43);
  cprintf("%s",a);
  cprintf("%s",aa);
  a[0]=191;
  cprintf("%s",a);
  a[0]=179;

  gotoxy(2,44);
  cprintf("%s",a);
  textcolor(BLACK);
  cprintf("%s","R");
  textcolor(DARKGRAY);
  cprintf("%s","estart ");
  cprintf("%s",a);

  gotoxy(2,45);
  cprintf("%s",a);
  textcolor(BLACK);
  cprintf("%s","S");
  textcolor(DARKGRAY);
  cprintf("%s","ave    ");
  cprintf("%s",a);

  gotoxy(2,46);
  cprintf("%s",a);
  textcolor(DARKGRAY);
  cprintf("%s","save ");
  textcolor(BLACK);
  cprintf("%s","A");
  textcolor(DARKGRAY);
  cprintf("%s","s ");
  cprintf("%s",a);

  gotoxy(2,47);
  cprintf("%s",a);
  textcolor(BLACK);
  cprintf("%s","L");
  textcolor(DARKGRAY);
  cprintf("%s","oad    ");
  cprintf("%s",a);

  gotoxy(2,48);
  cprintf("%s",a);
  textcolor(BLACK);
  cprintf("%s","Q");
  textcolor(DARKGRAY);
  cprintf("%s","uit    ");
  cprintf("%s",a);

  a[0]=195;
  gotoxy(2,49);
  cprintf("%s",a);
  a[0]=193;
  gotoxy(11,49);
  cprintf("%s",a);

  menus=1;
}

void drawoptions()
{
  char a[2]= {218,NULL}, aa[11]={196,196,196,196,196,196,196,196,196,196,NULL};
  textcolor(DARKGRAY);
  textbackground(WHITE);
  gotoxy(68,44);
  cprintf("%s",a);
  cprintf("%s",aa);
  a[0]=191;
  cprintf("%s",a);
  a[0]=179;

  gotoxy(68,45);
  cprintf("%s",a);
  textcolor(BLACK);
  cprintf("%s","B");
  textcolor(DARKGRAY);
  cprintf("%s","ack move ");
  cprintf("%s",a);

  gotoxy(68,46);
  cprintf("%s",a);
  textcolor(BLACK);
  cprintf("%s","C");
  textcolor(DARKGRAY);
  cprintf("%s","hange set");
  cprintf("%s",a);

  gotoxy(68,47);
  cprintf("%s",a);
  textcolor(BLACK);
  cprintf("%s","P");
  textcolor(DARKGRAY);
  cprintf("%s","uzzles   ");
  cprintf("%s",a);

  gotoxy(68,48);
  cprintf("%s",a);
  textcolor(BLACK);
  cprintf("%s","T");
  textcolor(DARKGRAY);
  cprintf("%s","imers    ");
  cprintf("%s",a);

  a[0]=193;
  gotoxy(68,49);
  cprintf("%s",a);
  a[0]=180;
  gotoxy(79,49);
  cprintf("%s",a);

  menus=2;
}

void erasemenu1()
{
  char a[2]={218,NULL};
  textbackground(BLACK);
  for (int x=43 ; x<49 ; x++)
    {
      gotoxy(2,x);
      cprintf("%s","           ");
    }
  textbackground(WHITE);
  textcolor(DARKGRAY);
  gotoxy(2,49);
  cprintf("%s",a);
  a[0]=196;
  gotoxy(11,49);
  cprintf("%s",a);
  menus=0;
}

void erasemenu2()
{
  char a[2]={191,NULL};
  textbackground(BLACK);
  for (int x=44 ; x<49 ; x++)
    {
      gotoxy(68,x);
      cprintf("%s","             ");
    }
  textbackground(WHITE);
  textcolor(DARKGRAY);
  gotoxy(79,49);
  cprintf("%s",a);
  a[0]=196;
  gotoxy(68,49);
  cprintf("%s",a);
  menus=0;
}

void clrbuf()
{
  while (kbhit())
    _getch();
}

void clearback()
{
  history *f=first,*f2;
  while(f!=NULL)
    {
      f2=f->next;
      delete(f);
      f=f2;
    }
}

void puzzle(side all[])
{
  clearback();
  sideinit(all);
  for (int x=0 ; x<2 ; x++)
    {
      for (int y=0 ; y<16 ; y++)
        {
          all[x].pieces[y].dead=1;
          all[x].pieces[y].moved=1;
        }
    }
  gettime();
  clocks[0]-=clockrun;
  turn=0;
}

main()
{
  _setcursortype(_NOCURSOR);
  gettime();
  getset();
  int nul;
  char fname[15];
  fname[0]='a';
  clrscr();
  side all[2];
  cursor[0]=cursor[1]=4;
  int act=0, chose, chold[2], suc,check;
  char typein;
  chold[0]=chold[1]=1;
  sideinit(all);
  drawboard(all,0);
  while(1)
    {
      castled=0;
      if (strcmp(fname,"ab13513s")==0)
	{
	  system("del saved\\ab13513s");
	  fname[0]='b';
	}
      if (timeset==time(NULL))
        {
	  drawcursor(act, chold);
	  if (kbhit())
	    {
              nul=0;
	      typein=_getch();
              if (typein=='\0')
		{
		  nul=1;
		  typein=_getch();
		}
	      if (menus==1)
		erasemenu1();
	      if (menus==2)
		erasemenu2();
	      drawcursor2();
              clrbuf();
	    }
	  else
	    typein=' ';
	  switch(typein)
	    {
	    case 'f': case 'F':
	      drawfile();
	      break;
	    case 'c': case 'C':
	      changeset(all);
	      break;
	    case 'p': case 'P':
	      if (nul)
		cursor[1]--;
              else
                {
                  if (!puzzles)
                    {
                      puzzle(all);
                      act=0;
                      puzzles=1;
                    }
                }
	      break;
	    case 'M':
	      if (nul==1)
		cursor[0]++;
	      break;
	    case 'H':
	      if (nul==1)
		cursor[1]++;
	      break;
	    case 'K':
	      if (nul==1)
		cursor[0]--;
	      break;
	    case 'I':
	      if (nul==1)
		{
		  cursor[0]++;
		  cursor[1]++;
		}
	      break;
	    case 'G':
	      if (nul==1)
		{
		  cursor[0]--;
		  cursor[1]++;
		}
	      break;
	    case 'O': case 'o':
	      if (nul==1)
		{
		  cursor[0]--;
		  cursor[1]--;
		}
	      else
		drawoptions();
	      break;
	    case 'Q': case 'q':
	      if (nul==1)
		{
		  cursor[0]++;
		  cursor[1]--;
		}
	      else
		{
		  _setcursortype(_NORMALCURSOR);
		  textbackground(BLACK);
		  textcolor(LIGHTGRAY);
		  clrscr();
		  exit(0);
		}
	      break;
	    case 's': case 'S':
	      if (strcmp(savename,"abc132eli")!=0)
		{
		  savegame(all, clocks, chold, act,fname);
		  break;
		}
	    case 'a': case 'A':
	      textbackground(BLACK);
	      textcolor(LIGHTGRAY);
	      getname(fname,1);
	      if (strcmp(fname,"ab13513s")!=0)
		strcpy(savename,fname);
	      savegame(all, clocks, chold, act,fname);
	      act=loadgame(all, clocks, chold, act,fname);
	      break;
	    case 'l': case 'L':
	      textbackground(BLACK);
	      textcolor(LIGHTGRAY);
	      getname(fname,0);
	      if (strcmp(fname,"ab13513s")==0)
		savegame(all, clocks, chold, act,fname);
	      else
		strcpy(savename,fname);
	      act=loadgame(all, clocks, chold, act,fname);
	      break;
	    case 'n': case 'N':
	      textbackground(BLACK);
	      textcolor(LIGHTGRAY);
	      clrscr();
	      sideinit(all);
	      drawboard(all,1);
              gettime();
	      break;
            case 't': case 'T':
              clockstuff();
              break;
	    case 'b': case 'B':
	      if (first!=NULL && puzzles!=1)
		{
		  turn=abs(turn-1);
		  back(all);
		  act=0;
		  drawboard(all,0);
		}
	      break;











	    case char(13):
              drawcursor(0,chold);
	      if(act==0)
		{
		  if(piececheck(all, cursor[0], cursor[1])==1)
		    {
		      chold[0]=cursor[0];
		      chold[1]=cursor[1];
		      act=1;
			  chose=selpiece(all);
		    }
		}
	      else
		{
		  if (chold[0]!=cursor[0] || chold[1]!=cursor[1])
		    suc=movpiece(all, chose, chold,0);
		  else
		    turn=abs(turn-1);
		  if(suc==0 && (chold[0]!=cursor[0] || chold[1]!=cursor[1]))
		    {
		      gotoxy(35, 42);
		      cout<<"ILLEGAL MOVE.";
		      wait(2);
		      gotoxy(35, 42);
		      cout<<"             ";
		      turn=abs(turn-1);
		    }
		  if (suc==1)
		    perp++;
		  drawdead(all);
		  turn=abs(turn-1);
		  check=checkcheck(all, all[turn].pieces[15].x , all[turn].pieces[15].y);
		  if(check>0)
		    {
		      drawboard(all,0);
		      if(checkmatecheck(all)==1)
			{
			  gotoxy(35, 42);
			  cout<<"CHECKMATE!        ";
                          clockrun=0;
			}
	              else
		        showcheck();
		    }
		  else
		    if (checkmatecheck(all)==1 || perp==100)
		      stalemate();
		  act=0;
                  if(checkmatecheck(all)==0)
		    drawboard(all,0);
		}
	      break;
	    };













        for (int ab=0 ; ab<2 ; ab++)
          if (cursor[ab]==9 || cursor[ab]==0)
             cursor[ab]-=((float)cursor[ab]-4.5)/4.5;
	}
      else
	{
	  timeset=time(NULL);
          if (clockrun==1)
	    clocks[turn]-=1-puzzles;
          if (clocks[turn]==0)
            {
              clockrun=0;
              gotoxy(35, 42);
              cout<<"Time's up!  ";
              gotoxy(19+37*turn,45);
              cout<<"--:--";
            }
          if (clockrun!=0)
  	    drawtime();
	}
    }
}




















